*==============================================================================
* Program:			md5_test
* Purpose:			 hash- (MD5, SHA1, SHA256) 
* Author:			Alexander Kagarmanov
* Last revision:	04.09.2005
* Version FoxPro:	5.0a
* License			Public Domain
*==============================================================================
*
_SCREEN.FONTNAME = "courier new"
CLEAR
***        
IF NOT "FOXMD5.FLL" $ UPPER(SET("LIBRARY"))
	SET LIBRARY TO C:\DevStudio\work\md5\FoxHash.fll ADDITIVE
ENDIF
*
LOCAL lcFileMD, FileMD, lcPartFile, lnFileSize, lcmd5, lcmd5f
lcFileMD = "c:\DevStudio\WORK\MD5\Source.zip"	&&  
*
***------------- MD5   --------------------
IF FILE(lcFileMD)								&&    ?
	FileMD = FOPEN(lcFileMD)					&&  ""   read only
	IF FileMD < 0								&&     
		WAIT "Cannot open file" WINDOW TIMEOUT 3
	ELSE										&&   ,  
		lnFileSize = FSEEK(FileMD, 0, 2)		&&   ,   lnFileSize
		FSEEK(FileMD, 0)
		IF lnFileSize =< 5242880				&&    5 
			lcPartFile = FREAD(FileMD, lnFileSize)	&&     (  =  )
			lcmd5 = MD5HASH(lcPartFile)				&&  MD5  
			lcsha1 = SHA1HASH(lcPartFile)
			lcsha2 = SHA2HASH(lcPartFile)
		ELSE
			lcmd5 = "000"
			lcsha1 = "000"
			lcsha2 = "000"
		ENDIF
		= FCLOSE(FileMD)						&&  
	ENDIF
	lcmd5f = MD5HASHFILE(lcFileMD)				&&  MD5  
	? "MD5HashFile	=",UPPER(lcmd5f)
	? "MD5Hash		=",lcmd5
	?
	? "SHA1HashFile	=",SHA1HASHFILE(lcFileMD)
	? "SHA1Hash	=",lcsha1
	?
	? "SHA2HashFile	=",SHA2HASHFILE(lcFileMD)
	? "SHA2Hash	=",lcsha2
	?
	? "Hash verify  (MD5) =",VerifyHashFile(lcFileMD, lcmd5)
	? "Hash verify (SHA1) =",VerifyHashFile(lcFileMD, lcsha1)
	? "Hash verify (SHA2) =",VerifyHashFile(lcFileMD, lcsha2)
	? "Hash verify (test) =",VerifyHashFile(lcFileMD, "8f7652d6ef7889ef993f8aff")
ELSE
	WAIT "File not found" WINDOW TIMEOUT 3
ENDIF
*
SET LIBRARY TO
***---------------- END ---------------------------------
